<ng-container *ngIf="institution">
  <h1>{{ institution.name !== '' ? institution.name : 'New Institution' }}</h1>

  <mat-accordion [multi]="false">
    <mat-expansion-panel
      hideToggle
      expanded
      class="has-required"
      [class.invalid]="!generalInformationValid"
    >
      <mat-expansion-panel-header>
        <mat-panel-title>
          <mat-icon
            matTooltip="Section contains required fields"
            [color]="generalInformationValid ? 'primary' : 'accent'"
            class="required-info"
          >
            label_important
          </mat-icon>
          <span>General Information</span>
        </mat-panel-title>
        <mat-panel-description></mat-panel-description>
      </mat-expansion-panel-header>

      <ng-container *ngIf="isExisting$ | async; else newInstitution">
        <p>You are adding onto an existing institution.</p>

        <p>{{ institution.name }}</p>

        <p *ngIf="institution.university">{{ institution.university }}</p>
      </ng-container>
      <ng-template #newInstitution>
        <p>Add a new institution</p>

        <mat-form-field>
          <mat-label>Name</mat-label>
          <input
            matInput
            type="text"
            name="name"
            placeholder="Enter the name of the institution"
            [(ngModel)]="institution.name"
            required
          />
          
        </mat-form-field>

        <mat-form-field>
          <mat-label>University</mat-label>
          <input
            matInput
            type="text"
            name="university"
            placeholder="Enter the name of the university this institution belongs to"
            [(ngModel)]="institution.university"
          />
          
        </mat-form-field>
      </ng-template>
    </mat-expansion-panel>

    <mat-expansion-panel
      hideToggle
      class="has-required"
      [class.invalid]="!(anyRoleSelected$ | async)"
    >
      <mat-expansion-panel-header>
        <mat-panel-title>
          <mat-icon
            matTooltip="Section contains required fields"
            [color]="(anyRoleSelected$ | async) ? 'primary' : 'accent'"
            class="required-info"
          >
            label_important
          </mat-icon>
          <span>Role selection</span>
        </mat-panel-title>
        <mat-panel-description></mat-panel-description>
      </mat-expansion-panel-header>

      <p *ngIf="!(anyRoleSelected$ | async)">You need to select at least one role</p>
      <div class="role-selection">
        <mat-checkbox
          *ngFor="let role of availableRoles"
          [(ngModel)]="role.checked"
          (change)="updateRoles()"
        >
          {{ role.value }}
        </mat-checkbox>
      </div>
    </mat-expansion-panel>

    <mat-expansion-panel hideToggle class="has-required" [class.invalid]="!addressValid">
      <mat-expansion-panel-header>
        <mat-panel-title>
          <mat-icon
            matTooltip="Section contains required fields"
            [color]="addressValid ? 'primary' : 'accent'"
            class="required-info"
          >
            label_important
          </mat-icon>
          <span>Address</span>
        </mat-panel-title>
        <mat-panel-description></mat-panel-description>
      </mat-expansion-panel-header>

      <ng-container *ngIf="availableAddresses$ | async as availableAddresses">
        <ng-container *ngIf="selectedAddress$ | async as selectedAddress">
          <p>
            You can choose an existing address or attach a new one. We've already selected the most
            recent address for you.
          </p>

          <mat-form-field appearance="fill">
            <mat-label>Existing address</mat-label>
            <mat-select (selectionChange)="selectAddress($event)">
              <mat-select-trigger>
                {{ selectedAddress.infoString }}
              </mat-select-trigger>
              <mat-option value="empty"> Empty Address </mat-option>
              <mat-option *ngFor="let address of availableAddresses" [value]="address._id">
                {{ address.infoString }}
              </mat-option>
            </mat-select>
          </mat-form-field>
        </ng-container>
      </ng-container>

      <app-address
        *ngIf="institution.addresses[entityId] as address"
        [address]="address"
      ></app-address>
    </mat-expansion-panel>

    <mat-expansion-panel hideToggle>
      <mat-expansion-panel-header>
        <mat-panel-title>
          <mat-icon matTooltip="Section is optional" color="primary" class="required-info">
            label
          </mat-icon>
          <span>Additional</span>
        </mat-panel-title>
        <mat-panel-description></mat-panel-description>
      </mat-expansion-panel-header>

      <mat-form-field class="fullwidth">
        <mat-label>Note</mat-label>
        <input
          matInput
          type="text"
          name="note"
          placeholder="Add a note"
          [(ngModel)]="institution.notes[entityId]"
        />
        
      </mat-form-field>
    </mat-expansion-panel>
  </mat-accordion>
</ng-container>
